open List

(* 1 *)
let rec nth l n =
    match n with
    | 0 -> hd l
    | i when i > 0 && i < (length l) -> nth (tl l) (i - 1)
    | _ -> raise (Failure "list index out of bounds")
;;

(* 2 *)
let heads l = map hd l;;

(* 3 *)
let zip l m =
    let rec cut l e = if e = (length l) then l else cut (rev (tl (rev l))) e in
    let min a b = if a > b then b else a in
    let len = min (length l) (length m) in
    combine (cut l len) (cut m len)
;;

(* 4 *)
let rec map f l =
    match l with
    | [] -> []
    | h::t -> f h::map f t
;;

(* 5 *)
let rec reduce f z l =
    match l with
    | [] -> z
    | h::t -> f z (reduce f h t)
;;

(* 6 *)
let rec isSublist l s =
    match s with
    | [] -> true
    | h::t -> h = (hd l) && isSublist (tl l) t
;;

(* 7 *)
let rec lookup l key =
    match l with
    | [] -> raise (Failure "lookup")
    | h::t -> let k, v = h in if k = key then v else lookup t key
;;

(* Challenge *)
let rec coin_permutation l n =
    let perms coin l =
        match coin with
        | i when i < n -> 1 + (coin_permutation l (n - coin))
        | i when i = n -> 1
        | _ -> 0
    in
    match l with
    | [] -> 0
    | h::t -> (perms h t) + (coin_permutation t n)
;;
